before_script:
  - echo "deb http://toolbelt.heroku.com/ubuntu ./" > /etc/apt/sources.list.d/heroku.list
  - wget -O- https://toolbelt.heroku.com/apt/release.key | apt-key add -
  - apt-get update
  - apt-get install -y heroku-toolbelt
  - gem install dpl
  - apt-get install libjpeg-dev zlib1g-dev

stages:
  - test
  - deploy
  - migrate

flake8:
  stage: test
  image: python:3.6
  before_script:
    - pip install -q flake8
  script:
    - flake8

coverage:
  stage: test
  image: python:3.6
  before_script:
    - pip install -r environments/requirements-local.txt
  script:
    - coverage run manage.py test
    - coverage html && coverage report
  coverage: "/TOTAL.+ ([0-9]{1,3}%)/"
  artifacts:
    paths:
      - htmlcov
    expire_in: 30 days

pytest:
  stage: test
  image: python:3.6
  before_script:
    - pip install -r environments/requirements-local.txt
  script:
    - python manage.py test

deploy:
  stage: deploy
  script:
    - dpl --provider=heroku --app=$HEROKU_APP_PRODUCTION --api-key=$HEROKU_API_KEY
  only:
    - develop

migrate:
  stage: deploy
  extends: deploy
  script:
    - heroku run python manage.py migrate --exit-code --app $HEROKU_APP_PRODUCTION
  when: on_success

pages:
  stage: deploy
  extends: deploy
  script:
    - mkdir -p public/coverage
    - mv htmlcov/* public/coverage
  artifacts:
    paths:
      - public
    expire_in: 30 days
  only:
    - develop
